package model.arbitre;

import model.CellulesVivantes;
import model.plateau.Plateau;
import model.cellule.CellState;

public class ArbitreConwayStyle extends Arbitre{

	public ArbitreConwayStyle(Plateau plateau) {
		super(plateau);
	}

	@Override
	public CellState VerifierChangementCellules(int x, int y) {
		if(verifierNaissance(x, y)) {
			return CellState.BIRTH;
		}
		if(verifierMort(x, y)) {
			return CellState.DIE;
		}
		return getPlateau().getCell(x, y).isAlive() ? CellState.LIVE : CellState.DIE;
	}

	private boolean verifierNaissance(int x, int y) {
		int cpt = getCompteurCell().compteNombreCellulesAutour(x, y, getCellulesVivantes());
		if(cpt == 3 && !getPlateau().getCell(x, y).isAlive()) {
		 	return true;
		}
		return false;
	}

	private boolean verifierMort(int x, int y) {
		int cpt = getCompteurCell().compteNombreCellulesAutour(x, y, getCellulesVivantes());
		if(!(cpt == 2 || cpt == 3) && getPlateau().getCell(x, y).isAlive()) {
		 	return true;
		}
		return false;
	}
}
