package model.plateau;

import javafx.beans.property.*;
import model.cellule.Cellule;
import model.cellule.créateur.CreateurCellule;

import java.util.List;

public class Plateau implements PrototypePlateau{
	private CreateurCellule createurCellule;
	private IntegerProperty longueur = new SimpleIntegerProperty();
		public int getLongueur() { return longueur.get();}
		public void setLongueur(int valeur) { longueur.set(valeur);	resetGrille(getLargeur(), valeur);}
		public IntegerProperty longueurProperty() { return longueur; }

	private IntegerProperty largeur = new SimpleIntegerProperty();
		public int getLargeur() { return largeur.get(); }
		public void setLargeur( int valeur ) { largeur.set(valeur); resetGrille(valeur, getLongueur());}
		public IntegerProperty largeurProperty() { return largeur; }

	//private ObservableList<List<Cellule>> grilleObs = FXCollections.observableArrayList();
	private ListProperty<List<Cellule>> grille = new SimpleListProperty<>();
		public ListProperty<List<Cellule>> getGrille() { return (ListProperty<List<Cellule>>) grille.get(); }
		public void setGrille(ListProperty<List<Cellule>> cells) {grille.set(cells);}
		public ReadOnlyListProperty grilleProperty() { return grille;}

	public Cellule getCell(int x, int y) throws IllegalArgumentException{
		if(x < 0 || y < 0) {
			throw new IllegalArgumentException("X ou Y est inférieur à 0");
		}
		if(y >= getGrille().size()){
			throw new IllegalArgumentException("Y est trop grand !!!");
		}
		if(x >= getGrille().get(y).size()){
			throw new IllegalArgumentException("X est trop grand !!!");
		}
		return grille.get().get(y).get(x);
	}

	public void resetGrille(){
			resetGrille(getLargeur(), getLongueur());
	}
	public void resetGrille(int w, int h){
			setGrille(createurCellule.creerCellules(w, h));
	}

	public Plateau(){
			createurCellule = new CreateurCellule(0, 0);
			setGrille(new SimpleListProperty<>());
		}
	public Plateau(int longueur, int largeur) {
		createurCellule = new CreateurCellule(longueur, largeur);
		setLargeur(largeur);
		setLongueur(longueur);
		setGrille(createurCellule.creerCellules());
	}

	public Plateau(int longueur, int largeur, ListProperty<List<Cellule>> cellules)
	{
		this(longueur, largeur);
		setGrille(cellules);
	}

	@Override
	public Plateau cloner() {
		return new Plateau(getLongueur(), getLargeur(), getGrille());
	}
}
